VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form FillPixelsForm 
   Caption         =   "Resizer []"
   ClientHeight    =   5910
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   8340
   LinkTopic       =   "Form1"
   ScaleHeight     =   5910
   ScaleWidth      =   8340
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   2280
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DefaultExt      =   ".bmp"
   End
   Begin VB.PictureBox picSplitter 
      BackColor       =   &H00FFFFC0&
      BorderStyle     =   0  'None
      Height          =   2055
      Left            =   0
      MousePointer    =   9  'Size W E
      ScaleHeight     =   2055
      ScaleWidth      =   4455
      TabIndex        =   2
      Top             =   480
      Width           =   4455
      Begin VB.PictureBox picLeft 
         BackColor       =   &H0080FF80&
         BorderStyle     =   0  'None
         Height          =   1815
         Left            =   120
         MousePointer    =   1  'Arrow
         ScaleHeight     =   1815
         ScaleWidth      =   2055
         TabIndex        =   4
         Top             =   120
         Width           =   2055
         Begin VB.HScrollBar hbarLeft 
            Height          =   255
            Left            =   120
            TabIndex        =   12
            Top             =   1440
            Width           =   1455
         End
         Begin VB.VScrollBar vbarLeft 
            Height          =   1215
            Left            =   1680
            TabIndex        =   11
            Top             =   120
            Width           =   255
         End
         Begin VB.PictureBox picLeftWindow 
            Height          =   1215
            Left            =   120
            ScaleHeight     =   1155
            ScaleWidth      =   1395
            TabIndex        =   5
            Top             =   120
            Width           =   1455
            Begin VB.PictureBox picFrom 
               AutoRedraw      =   -1  'True
               BackColor       =   &H00FFFFFF&
               BorderStyle     =   0  'None
               Height          =   885
               Left            =   120
               ScaleHeight     =   885
               ScaleWidth      =   1095
               TabIndex        =   6
               Top             =   120
               Width           =   1095
            End
         End
      End
      Begin VB.PictureBox picRight 
         BackColor       =   &H0080FF80&
         BorderStyle     =   0  'None
         Height          =   1815
         Left            =   2280
         MousePointer    =   1  'Arrow
         ScaleHeight     =   1815
         ScaleWidth      =   2055
         TabIndex        =   3
         Top             =   120
         Width           =   2055
         Begin VB.HScrollBar hbarRight 
            Height          =   255
            Left            =   120
            TabIndex        =   10
            Top             =   1440
            Width           =   1455
         End
         Begin VB.VScrollBar vbarRight 
            Height          =   1215
            Left            =   1680
            TabIndex        =   9
            Top             =   120
            Width           =   255
         End
         Begin VB.PictureBox picRightWindow 
            Height          =   1215
            Left            =   120
            ScaleHeight     =   1155
            ScaleWidth      =   1395
            TabIndex        =   7
            Top             =   120
            Width           =   1455
            Begin VB.PictureBox picTo 
               AutoRedraw      =   -1  'True
               BackColor       =   &H00FFFFFF&
               BorderStyle     =   0  'None
               Height          =   855
               Left            =   120
               ScaleHeight     =   855
               ScaleWidth      =   1095
               TabIndex        =   8
               Top             =   120
               Width           =   1095
            End
         End
      End
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   405
      Left            =   1320
      TabIndex        =   0
      Top             =   0
      Width           =   615
   End
   Begin VB.Label lblHoleColor 
      BackColor       =   &H000000FF&
      Height          =   375
      Left            =   840
      TabIndex        =   13
      Top             =   0
      Width           =   375
   End
   Begin VB.Label Label1 
      Caption         =   "Hole Color"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   75
      Width           =   735
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuFileSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "FillPixelsForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const SASH_WIDTH = 60
Private SashPosition As Single

' Sash dragging variables.
Private Dragging As Boolean
' Resize the image.
Private Sub cmdGo_Click()
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Fill the holes.
    FillHoles

    ' Rearrange the picTo scroll bars.
    ArrangeRight

    Screen.MousePointer = vbDefault
End Sub
' Resize the image.
Private Sub FillHoles()
Dim pixels() As RGBTriplet
Dim bits_per_pixel As Integer
Dim maxX As Integer
Dim maxY As Integer
Dim Y As Integer
Dim hole_r As Integer
Dim hole_g As Integer
Dim hole_b As Integer
Dim hole_start As Integer
Dim hole_stop As Integer
Dim found_start As Boolean
Dim found_stop As Boolean
Dim r0 As Single
Dim g0 As Single
Dim b0 As Single
Dim dr As Single
Dim dg As Single
Dim db As Single
Dim i As Integer

    Screen.MousePointer = vbHourglass
    DoEvents

    ' Get the holes' RGB values.
    UnRGB lblHoleColor.BackColor, hole_r, hole_g, hole_b

    ' Get the input image's pixels.
    GetBitmapPixels picFrom, pixels, bits_per_pixel

    ' Get the pixel bounds.
    maxX = UBound(pixels, 1)
    maxY = UBound(pixels, 2)

    ' Fill in holes using linear
    ' interpolation on each scanline.
    For Y = 0 To maxY
        hole_start = 1
        Do While hole_start < maxX
            ' Find where the next hole starts.
            found_start = False
            Do While hole_start <= maxX
                With pixels(hole_start, Y)
                    If .rgbRed = hole_r And _
                       .rgbGreen = hole_g And _
                       .rgbBlue = hole_b _
                    Then
                        found_start = True
                        Exit Do
                    End If
                End With
                hole_start = hole_start + 1
            Loop

            ' See if we found the start of a hole.
            If Not found_start Then Exit Do

            ' Find where this hole ends.
            found_stop = False
            hole_stop = hole_start + 1
            Do While hole_stop <= maxX
                With pixels(hole_stop, Y)
                    If .rgbRed <> hole_r Or _
                       .rgbGreen <> hole_g Or _
                       .rgbBlue <> hole_b _
                    Then
                        found_stop = True
                        Exit Do
                    End If
                End With
                hole_stop = hole_stop + 1
            Loop

            ' See if we found the end of a hole.
            If Not found_stop Then Exit Do

            ' Make hole_stop point to
            ' the last pixel in the hole.
            hole_stop = hole_stop - 1

            ' Get the color before the hole.
            With pixels(hole_start - 1, Y)
                r0 = .rgbRed
                g0 = .rgbGreen
                b0 = .rgbBlue
            End With

            ' Calculate the difference per pixel.
            With pixels(hole_stop + 1, Y)
                dr = (.rgbRed - r0) / (hole_stop - hole_start + 2)
                dg = (.rgbGreen - g0) / (hole_stop - hole_start + 2)
                db = (.rgbBlue - b0) / (hole_stop - hole_start + 2)
            End With

            ' Fill the hole.
            For i = hole_start To hole_stop
                r0 = r0 + dr
                g0 = g0 + dg
                b0 = b0 + db
                With pixels(i, Y)
                    .rgbRed = r0
                    .rgbGreen = g0
                    .rgbBlue = b0
                End With
            Next i

            ' Get ready to find the next hole.
            hole_start = hole_stop + 1
        Loop
    Next Y

    ' Display the result.
    SetBitmapPixels picTo, bits_per_pixel, pixels

    Screen.MousePointer = vbDefault
End Sub

Private Sub Form_Load()
Dim ctl As Control

    SashPosition = (ScaleWidth - SASH_WIDTH) / 2

    dlgFile.Filter = _
        "Bitmap (*.bmp)|*.bmp|" & _
        "JPEG (*.jpg, *.jpeg)|*.jpg;*.jpeg|" & _
        "GIF (*.gif)|*.gif|" & _
        "Graphics Files (*.bmp, *.jpg, *.jpeg, *.gif)|*.bmp;*.jpg;*.jpeg;*.gif|" & _
        "All Files (*.*)|*.*|"
    dlgFile.InitDir = App.Path

    picFrom.AutoSize = True
    picFrom.AutoRedraw = True
    picFrom.ScaleMode = vbPixels
    picFrom.Picture = LoadPicture("")
    picFrom.Move 0, 0, 1, 1

    picTo.AutoSize = True
    picTo.AutoRedraw = True
    picTo.ScaleMode = vbPixels
    picFrom.Picture = LoadPicture("")
    picTo.Move 0, 0, 1, 1

    picLeftWindow.Move 0, 0, 1, 1
    picRightWindow.Move 0, 0, 1, 1

    cmdGo.Enabled = False

    ' Give all PictureBoxes the form's BackColor.
    For Each ctl In Controls
        If TypeOf ctl Is PictureBox Then
            ctl.BackColor = BackColor
        End If
    Next ctl
End Sub
' Make the splitter area as large as possible.
Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    If WindowState = vbMinimized Then Exit Sub

    wid = ScaleWidth
    If wid < 240 Then wid = 240
    hgt = ScaleHeight - cmdGo.Top - cmdGo.Height
    If hgt < 120 Then hgt = 120
    picSplitter.Move 0, cmdGo.Top + cmdGo.Height, _
        ScaleWidth, hgt
End Sub

' Unload the form.
Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' Open an image file.
Private Sub mnuFileOpen_Click()
Dim fname As String

    ' Allow the user to pick a file.
    On Error Resume Next
    dlgFile.CancelError = True
    dlgFile.Flags = cdlOFNFileMustExist + cdlOFNHideReadOnly
    dlgFile.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error selecting file.", , vbExclamation
        Exit Sub
    End If
    On Error GoTo 0

    fname = Trim$(dlgFile.FileName)
    dlgFile.InitDir = Left$(fname, Len(fname) _
        - Len(dlgFile.FileTitle) - 1)

    ' Load the picture.
    Screen.MousePointer = vbHourglass
    DoEvents

    picFrom.Picture = LoadPicture(fname)
    picFrom.Picture = picFrom.Image
    picTo.Picture = picFrom.Picture
    ArrangeLeft
    ArrangeRight

    Caption = "FillPixels [" & dlgFile.FileTitle & "]"
    cmdGo.Enabled = True
    Screen.MousePointer = vbDefault
End Sub
' Rearrange the controls in the left pane.
Private Sub ArrangeLeft()
Dim need_hgt As Single
Dim need_wid As Single
Dim got_hgt As Single
Dim got_wid As Single
Dim need_hbar As Boolean
Dim need_vbar As Boolean

    need_wid = picFrom.Width - (picLeftWindow.ScaleWidth - picLeftWindow.Width)
    need_hgt = picFrom.Height - (picLeftWindow.ScaleHeight - picLeftWindow.Height)
    got_wid = picLeft.ScaleWidth
    got_hgt = picLeft.ScaleHeight

    ' See if we need the horizontal scroll bar.
    need_hbar = (got_wid < need_wid)
    If need_hbar Then
        got_hgt = got_hgt - hbarLeft.Height
    End If

    ' See if we need the vertical scroll bar.
    need_vbar = (got_hgt < need_hgt)
    If need_vbar Then
        got_wid = got_wid - vbarLeft.Width

        ' See if we did not need the horizontal
        ' scroll bar but we now do.
        If Not need_hbar Then
            need_hbar = (got_wid < need_wid)
            If need_hbar Then
                got_hgt = got_hgt - hbarLeft.Height
            End If
        End If
    End If
    If got_hgt < 120 Then got_hgt = 120
    If got_wid < 120 Then got_wid = 120

    ' Display the needed scroll bars.
    If need_hbar Then
        hbarLeft.Move 0, got_hgt, got_wid
        hbarLeft.Min = 0
        hbarLeft.Max = got_wid - need_wid
        hbarLeft.SmallChange = got_wid / 3
        On Error Resume Next
        hbarLeft.LargeChange = _
            (hbarLeft.Max - hbarLeft.Min) _
                * need_wid / _
                (got_wid - need_wid)
        On Error GoTo 0
        hbarLeft.Visible = True
    Else
        hbarLeft.Value = 0
        hbarLeft.Visible = False
    End If
    If need_vbar Then
        vbarLeft.Move got_wid, 0, vbarLeft.Width, got_hgt
        vbarLeft.Min = 0
        vbarLeft.Max = got_hgt - need_hgt
        vbarLeft.SmallChange = got_hgt / 3
        vbarLeft.LargeChange = _
            (vbarLeft.Max - vbarLeft.Min) _
                * need_hgt / _
                (got_hgt - need_hgt)
        vbarLeft.Visible = True
    Else
        vbarLeft.Value = 0
        vbarLeft.Visible = False
    End If

    ' Arrange the window.
    picLeftWindow.Move 0, 0, got_wid, got_hgt
End Sub
' Rearrange the controls in the right pane.
Private Sub ArrangeRight()
Dim need_hgt As Single
Dim need_wid As Single
Dim got_hgt As Single
Dim got_wid As Single
Dim need_hbar As Boolean
Dim need_vbar As Boolean

    need_wid = picTo.Width - (picRightWindow.ScaleWidth - picRightWindow.Width)
    need_hgt = picTo.Height - (picRightWindow.ScaleHeight - picRightWindow.Height)
    got_wid = picRight.ScaleWidth
    got_hgt = picRight.ScaleHeight

    ' See if we need the horizontal scroll bar.
    need_hbar = (got_wid < need_wid)
    If need_hbar Then
        got_hgt = got_hgt - hbarRight.Height
    End If

    ' See if we need the vertical scroll bar.
    need_vbar = (got_hgt < need_hgt)
    If need_vbar Then
        got_wid = got_wid - vbarRight.Width

        ' See if we did not need the horizontal
        ' scroll bar but we now do.
        If Not need_hbar Then
            need_hbar = (got_wid < need_wid)
            If need_hbar Then
                got_hgt = got_hgt - hbarRight.Height
            End If
        End If
    End If
    If got_hgt < 120 Then got_hgt = 120
    If got_wid < 120 Then got_wid = 120

    ' Display the needed scroll bars.
    If need_hbar Then
        hbarRight.Move 0, got_hgt, got_wid
        hbarRight.Min = 0
        hbarRight.Max = got_wid - need_wid
        hbarRight.SmallChange = got_wid / 3
        hbarRight.LargeChange = _
            (hbarRight.Max - hbarRight.Min) _
                * need_wid / _
                (got_wid - need_wid)
        hbarRight.Visible = True
    Else
        hbarRight.Value = 0
        hbarRight.Visible = False
    End If
    If need_vbar Then
        vbarRight.Move got_wid, 0, vbarRight.Width, got_hgt
        vbarRight.Min = 0
        vbarRight.Max = got_hgt - need_hgt
        vbarRight.SmallChange = got_hgt / 3
        vbarRight.LargeChange = _
            (vbarRight.Max - vbarRight.Min) _
                * need_hgt / _
                (got_hgt - need_hgt)
        vbarRight.Visible = True
    Else
        vbarRight.Value = 0
        vbarRight.Visible = False
    End If

    ' Arrange the window.
    picRightWindow.Move 0, 0, got_wid, got_hgt
End Sub

' Save the output image.
Private Sub mnuFileSaveAs_Click()
Dim fname As String
Dim pos As Integer

    fname = dlgFile.FileName
    pos = InStrRev(fname, ".")
    If pos > 0 Then fname = Left$(fname, pos) & "bmp"
    dlgFile.FileName = fname

    ' Allow the user to pick a file.
    On Error Resume Next
    dlgFile.CancelError = True
    dlgFile.Flags = cdlOFNOverwritePrompt + cdlOFNHideReadOnly
    dlgFile.ShowSave
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error selecting file.", , vbExclamation
        Exit Sub
    End If
    On Error GoTo 0

    fname = Trim$(dlgFile.FileName)
    dlgFile.InitDir = Left$(fname, Len(fname) _
        - Len(dlgFile.FileTitle) - 1)

    ' Save the picture.
    Screen.MousePointer = vbHourglass
    DoEvents

    SavePicture picTo.Image, fname

    Caption = "FillPixels [" & dlgFile.FileTitle & "]"
    cmdGo.Enabled = True
    Screen.MousePointer = vbDefault
End Sub

' Select the clicked pixel's color.
Private Sub picFrom_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    lblHoleColor.BackColor = picFrom.Point(X, Y)
End Sub


' Rearrange the controls in the left pane.
Private Sub picLeft_Resize()
    ArrangeLeft
End Sub
' Rearrange the controls in the right pane.
Private Sub picRight_Resize()
    ArrangeRight
End Sub

' Drag the sash.
Private Sub picSplitter_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If (Button And vbLeftButton) = 0 Then Exit Sub

    SashPosition = X
    If SashPosition < 120 Then _
       SashPosition = 120
    If SashPosition > picSplitter.ScaleWidth - 120 Then _
       SashPosition = picSplitter.ScaleWidth - 120

    picSplitter_Resize
End Sub
' Make the panes as large as possible.
Private Sub picSplitter_Resize()
Dim wid2 As Single
Dim hgt As Single

    wid2 = picSplitter.ScaleWidth - SashPosition _
        - SASH_WIDTH
    If wid2 < 120 Then
        wid2 = 120
        SashPosition = picSplitter.ScaleWidth - _
            wid2 - SASH_WIDTH
    End If
    hgt = picSplitter.ScaleHeight

    picLeft.Move 0, 0, SashPosition, hgt
    picRight.Move SashPosition + SASH_WIDTH, 0, _
        wid2, hgt
End Sub

' Move the picture.
Private Sub vbarLeft_Change()
    picFrom.Top = vbarLeft.Value
End Sub
' Move the picture.
Private Sub vbarRight_Change()
    picTo.Top = vbarRight.Value
End Sub
' Move the picture.
Private Sub vbarRight_Scroll()
    picTo.Top = vbarRight.Value
End Sub
' Move the picture.
Private Sub vbarLeft_Scroll()
    picFrom.Top = vbarLeft.Value
End Sub
' Move the picture.
Private Sub hbarLeft_Scroll()
    picFrom.Left = hbarLeft.Value
End Sub
' Move the picture.
Private Sub hbarLeft_Change()
    picFrom.Left = hbarLeft.Value
End Sub
' Move the picture.
Private Sub hbarRight_Change()
    picTo.Left = hbarRight.Value
End Sub
' Move the picture.
Private Sub hbarRight_Scroll()
    picTo.Left = hbarRight.Value
End Sub
